Index: main/rtp.c
===================================================================
--- main/rtp.c	(revision 84361)
+++ main/rtp.c	(working copy)
@@ -3213,6 +3213,7 @@
 	ast_channel_unlock(c1);
 
 	ast_poll_channel_add(c0, c1);
+	ast_poll_channel_add(c1, c0);
 
 	/* Throw our channels into the structure and enter the loop */
 	cs[0] = c0;
@@ -3231,6 +3232,7 @@
 				if (pr1->set_rtp_peer(c1, NULL, NULL, NULL, 0, 0))
 					ast_log(LOG_WARNING, "Channel '%s' failed to break RTP bridge\n", c1->name);
 			ast_poll_channel_del(c0, c1);
+			ast_poll_channel_del(c1, c0);
 			return AST_BRIDGE_RETRY;
 		}
 
@@ -3317,6 +3319,7 @@
 				if (pr1->set_rtp_peer(c1, NULL, NULL, NULL, 0, 0))
 					ast_log(LOG_WARNING, "Channel '%s' failed to break RTP bridge\n", c1->name);
 			ast_poll_channel_del(c0, c1);
+			ast_poll_channel_del(c1, c0);
 			return AST_BRIDGE_COMPLETE;
 		} else if ((fr->frametype == AST_FRAME_CONTROL) && !(flags & AST_BRIDGE_IGNORE_SIGS)) {
 			if ((fr->subclass == AST_CONTROL_HOLD) ||
@@ -3365,6 +3368,7 @@
 	}
 
 	ast_poll_channel_del(c0, c1);
+	ast_poll_channel_del(c1, c0);
 
 	if (pr0->set_rtp_peer(c0, NULL, NULL, NULL, 0, 0))
 		ast_log(LOG_WARNING, "Channel '%s' failed to break RTP bridge\n", c0->name);
@@ -3497,6 +3501,7 @@
 	ast_channel_unlock(c1);
 
 	ast_poll_channel_add(c0, c1);
+	ast_poll_channel_add(c1, c0);
 
 	/* Go into a loop forwarding frames until we don't need to anymore */
 	cs[0] = c0;
@@ -3602,6 +3607,7 @@
 	p2p_set_bridge(p1, NULL);
 
 	ast_poll_channel_del(c0, c1);
+	ast_poll_channel_del(c1, c0);
 
 	return res;
 }
